<Cabbage>
form size(720, 200), caption("Stepseqencer"), pluginID("plu1"), colour(200,200,200)

label bounds(105, 20, 98, 15), text("Bpm Manual"), fontcolour("black")
numberbox bounds(105, 0, 98, 20), channel("Bpm_m"), colour("white"), fontcolour("black"), range(0, 555, 60, 1, 0.01)

label bounds(305, 20, 48, 15), text("Speed"), fontcolour("black")
numberbox bounds(305, 0, 48, 20), channel("Speed"), colour("white"), fontcolour("black"), range(0, 32, 1, 1, 0.001)

label bounds(355, 20, 48, 15), text("Error"), fontcolour("black")
numberbox bounds(355, 0, 48, 20), channel("Error"), colour("white"), fontcolour("black"), range(0, 1, 0, 1, 0.01)


button bounds(405, 0, 65, 39), channel("StartStop"), text("Play","Stop"), colour:0("black"), colour:1(200,215,200), value(0) 




image   bounds(5, 40, 700, 80), colour("white"), plant("seq1"), shape("sharp"), {
image   bounds(5, 5, 20, 40), colour(10,50,15,100), shape("sharp"), identchannel("ScrubberID1")
label bounds(5, 5, 20, 15), text("1"), fontcolour("black")
label bounds(85, 5, 20, 15), text("5"), fontcolour("black")
label bounds(165, 5, 20, 15), text("9"), fontcolour("black")
label bounds(245, 5, 20, 15), text("13"), fontcolour("black")
label bounds(325, 5, 20, 15), text("17"), fontcolour("black")
label bounds(405, 5, 20, 15), text("21"), fontcolour("black")
label bounds(485, 5, 20, 15), text("25"), fontcolour("black")
label bounds(565, 5, 20, 15), text("29"), fontcolour("black")
gentable bounds(5, 5, 640, 40), identchannel("table1"), tablenumber(1), tablecolour("red"), tablegridcolour(200, 200, 200),tablebackgroundcolour(255,255,255,0), active(1), amprange(0, 1, 1, 0.01), zoom(-1)

numberbox bounds(650, 5, 48, 20), channel("Steps1"), colour("white"), fontcolour("black"), range(1, 32, 16, 1, 1)
numberbox bounds(650, 25, 48, 20), channel("Speed1"), colour("white"), fontcolour("black"), range(0, 32, 1, 1, 0.001)
numberbox bounds(650, 45, 48, 15), channel("Note1"), colour("white"), fontcolour("black"), range(0, 127, 1, 1, 1)
button bounds(650, 60, 48, 15), channel("SamePit1"), text("Same","Same"), colour("black"), value(0), latched(0)
}


image   bounds(5, 140, 100, 50), colour("white"), plant("SF"), shape("sharp"), {
rslider bounds(5, 0, 50, 50), channel("PRESET"), range(1, 20, 1, 1, 1), textbox(1), trackercolour("black"),fontcolour("black"), textcolour("black")
button bounds(50, 5, 48, 20), channel("butsave"), text("Save", "Saving"), latched(0)
button bounds(50, 25, 48, 20), channel("butload"), text("Load", "Loading"), latched(0)
}



</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4
</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 64
nchnls = 2
0dbfs=1


#define PUTINTABLE(A)#
;Read gui and update memory ftable
kcountpit$A = 0
	nextpit$A:
		Schanpit$A sprintfk "Note%d_%d", k($A), kcountpit$A
		kval$A chnget Schanpit$A
		tablew kval$A, kcountpit$A, 10 + $A
	loop_le  kcountpit$A, 1, 31, nextpit$A
#



#define PITCHSAME(N)#
;assign the same value to the whole table and gui line
;by activating instr 9
ksp$N chnget "SamePit$N"
kref$N chnget "Note$N"
kcountIndexupd$N = 0
if changed(ksp$N) == 1 then
	nextupd$N:
		event "i", 9 + 0.001 * kcountIndexupd$N + 0.01 * $N, 0, -1, kref$N, kcountIndexupd$N, k($N)
	loop_le  kcountIndexupd$N, 1, 31, nextupd$N
endif
#





gkBPM init 60
giPerRow init 32



#define TABLESET(N)#
giMemV1$N ftgen 30 * $N + 1, 0, giPerRow, -2, 0
giMemV2$N ftgen 30 * $N + 2, 0, giPerRow, -2, 0
giMemV3$N ftgen 30 * $N + 3, 0, giPerRow, -2, 0
giMemV4$N ftgen 30 * $N + 4, 0, giPerRow, -2, 0
giMemV5$N ftgen 30 * $N + 5, 0, giPerRow, -2, 0
giMemP1$N ftgen 30 * $N + 11, 0, giPerRow, -2, 0
giMemP2$N ftgen 30 * $N + 12, 0, giPerRow, -2, 0
giMemP3$N ftgen 30 * $N + 13, 0, giPerRow, -2, 0
giMemP4$N ftgen 30 * $N + 14, 0, giPerRow, -2, 0
giMemP5$N ftgen 30 * $N + 15, 0, giPerRow, -2, 0
#

$TABLESET(0)
$TABLESET(1)
$TABLESET(2)
$TABLESET(3)
$TABLESET(4)
$TABLESET(5)
$TABLESET(6)
$TABLESET(7)
$TABLESET(8)
$TABLESET(9)
$TABLESET(10)
$TABLESET(11)
$TABLESET(12)
$TABLESET(13)
$TABLESET(14)
$TABLESET(15)
$TABLESET(16)
$TABLESET(17)
$TABLESET(18)
$TABLESET(19)
$TABLESET(20)
$TABLESET(21)
$TABLESET(22)












giSine ftgen 1000, 0, 2^16, 10, 1

;OSC receiving port
gihandle OSCinit 5775

instr 1
kbpm_m chnget "Bpm_m"
gkBPM = kbpm_m

;Start/stop
kStaSto chnget "StartStop"
if changed(kStaSto) == 1 && kStaSto == 1 then
	event "i", 20.01, 0, -1, 1
elseif changed(kStaSto) == 1 && kStaSto == 0 then
	event "i", -20.01, 0, -1, 1
endif



;Preset save load
kpreset chnget "PRESET"

ksave chnget "butsave"
ksavet changed ksave
if ksave == 1 && ksavet == 1 then
	event "i", 15, 0, -1, kpreset
endif

kload chnget "butload"
kloadt changed kload
if kload == 1 && kloadt == 1 then
	event "i", 18, 0, -1, kpreset
endif

;init others always on
event_i "i", 8, 0, -1;pitch storage
event_i "i", 17, 0, -1;load ftables at startup

endin




instr 8;store gui value and modified if all must be the same

$PUTINTABLE(1)
$PITCHSAME(1)
endin



instr 9;activated by $PITCHSAME
Schan sprintfk "Note%d_%d", k(p6), k(p5)
chnset p4, Schan
tablew p4, p5, 10 + p6
turnoff
endin




instr 15;ftsave
;copy current table in preset table and save ftable in the file
iadd = 30 * p4
tablecopy iadd + 1, 1
tablecopy iadd + 11, 11
Sfname sprintf "TPZ_SS_preset_%d", p4
ftsave Sfname, 1, 1,2,3,4,5,11,12,13,14,15
turnoff
endin



instr 17;load at startup
;print p1
icount = 1
doitagain:
	iadd = 30 * icount
	Sfname sprintf "TPZ_SS_preset_%d", icount
	ftload Sfname, 1, iadd + 1,iadd + 2, iadd+3,iadd+4, iadd+5, iadd+11, iadd+12, iadd+13, iadd+14, iadd+15
loop_lt icount, 1, 21, doitagain
turnoff
endin





instr 18;ftload
;print p1, p4
;preset = p4
Stab sprintf "f 1 0 %d -2", giPerRow
icountIndex = 0
nexttu:
	ival_upper table icountIndex, 30 * p4 + 1
	Sval sprintf " %f", ival_upper
	Stab strcat Stab, Sval
	;tablew ival_upper, icountIndex, 1
loop_le  icountIndex, 1, 31, nexttu
scoreline_i Stab
;update gentable gui
chnset "tablenumber(1)", "table1"
turnoff
endin





instr 20;metronome
Sstepsch	sprintf	"Steps%d",p4
ksteps chnget Sstepsch

Sspeesch	sprintf	"Speed%d",p4
kspeed chnget Sspeesch

kspeedGlobal chnget "Speed"

kerror chnget "Error"
ktime unirand kerror * 60 / (kspeedGlobal * kspeed * 4 * gkBPM)

ktr metro kspeedGlobal * kspeed * 4 * gkBPM / 60
kcount init -1
if ktr == 1 then
	kcount = (kcount + 1) % ksteps
	event "i", 22 + .0001 * p4 + 0.01 * kcount, ktime, -1, p4, kcount
endif
endin




instr 22;pointer
;print p4
iScrubPos	=	5 + (p5 * 20)			; derive x-position
Smsg	sprintf	"pos(%d,5)",iScrubPos			; create message string
Sscrubsch	sprintf	"ScrubberID%d",p4
chnset	Smsg, Sscrubsch				; send new position to widget

;note out
ivel tab_i p5, p4
inote tab_i p5, 10 + p4
if ivel > 0.01 then
	print ivel, inote
	event "i", 1000 + 0.01 * p4 + 0.001 * p5, 0, 25 / gkBPM, ivel, inote
endif
turnoff
endin






instr 1000;sine
print p1, p4
kenv linsegr 0, 0.05, p4, 0.1, 0
ao oscil kenv, cpsmidinn(p5), 1000
outs ao, ao

endin


</CsInstruments>  
<CsScore>
f0 z
i1 0 -1

</CsScore>
</CsoundSynthesizer>